//---------------------------------------------------------
//  RG Basic Tools Collection
//  Copyright © 2003,2004 Ronald D. Grindle
//
//This file is part of the Rslt services.
//
//Rslt services is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//Rslt services is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Rslt services.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------

package com.qanavigation.Basics;

import java.sql.*;

/** RsltTable is a table for conventional use. It's a 2 dimensional, 
* non-jagged array of Strings of a fixed size.
* The actual table m_2DArray is public, thus freely accessible.
* <p>RsltTable isA Rslt2DArray.
*/
public class RsltTable extends Rslt2DArray
{
	
	static final long serialVersionUID = 61940015;
	
	//private ResultSet m_ResSet;

	// Rslt extension ----------------------------

	// --------------------------------------------
	public void setRsltByExcp( SQLException p_Excp) {
	
		SQLException nxtExcp;
		
		while( null != (nxtExcp = p_Excp.getNextException()) ) {
			
			setRsltByExcp( nxtExcp );
		}
		
		addRsltAddInfo( "SQL state: " + p_Excp.getSQLState() );
		
		addRsltAddInfo( "Error code: " + p_Excp.getErrorCode() );
		
		super.setRsltByExcp( p_Excp );
	}
	// end Rslt extension -------------------------
	
	/**
	 * 
	 * @param p_Val
	 * @param p_Col
	 * @return
	 */
	public int findVal( String p_Val, int p_Col ) {
		
		int idx;
		int i, x;
		
		String val;
		String[] row;
		
		idx = -1;
		
		x = getRowNum();
		
		for( i = 0; i < x; ++i ) {
			
			row = getRow( i );
			
			val = row[ p_Col ];
			
			if( val.compareTo( p_Val ) == 0 ) {

				idx = i;
				
				i = x;
			}
		}
		
		return idx;
	}
	
	/**
	 * 
	 * @param p_Val
	 * @param p_FindCol
	 * @param p_ValCol
	 * @return
	 */
	public RsltString getValWhere( String p_Val, int p_FindCol, int p_ValCol ) {
		
		int i, x;
		
		RsltString rVal;
		
		String val;
		String[] row;
		
		rVal = new RsltString();
		
		x = getRowNum();
		
		for( i = 0; i < x; ++i ) {
			
			row = getRow( i );
			
			val = row[ p_FindCol ];
			
			if( val.compareTo( p_Val ) == 0 ) {
				
				i = x;
				
				rVal.setString( row[ p_ValCol ] );
			}
		}
		
		return rVal;
	}

	//	------------------------------------------
	/*
	public void init( ResultSet p_ResSet, String[] p_ColNames ) {
		
		init( p_ColNames.length );
		
		setColNames( p_ColNames );
		
		init( p_ResSet );
	}
	*/
	
	// ------------------------------------------
	/*
	protected void init( int p_Cols ) {
	
		m_ColNames = new String[ p_Cols ];
	}
	*/

	// ------------------------------------------
	/*
	public String getColName( int p_col ) {

		return m_ColNames[ p_col ];
	}
	*/
	
	// ------------------------------------------
	/*
	public void setColName( int p_col, String p_ColName ) {

		m_ColNames[ p_col ] = p_ColName;
	}
	*/
	
	// ------------------------------------------
	/*
	public void setColNames( String[] p_ColNames ) {
		
		int i, x;

		x = p_ColNames.length;

		for( i = 0; i < x; i++ ) {
		
			m_ColNames[ i ] = p_ColNames[ i ];
		}
	}
	*/
	
	public void setColSize( int p_Size ) {
		
		m_ColSize = p_Size;
	}

	public void setRowSize( int p_Size ) {
		
		m_RowSize = p_Size;
	}		
		
	// ------------------------------------------
	public SetList toSetLst( ) {
		
		SetList sLst;
		
		if( 1 != this.getColSize() ) {
			
			sLst = new SetList();
			
			sLst.setInError( "rg.Basics.RsltTable.toSetLst(): Can not convert RsltTable with colsize " 
				+  this.getColSize() + " to SetList" );		
		}
		else {
			
			sLst = new SetList( this );
			//??? sLst.setRsltStat( RsltStatVal.isEmpty );
		}
		
		return sLst;	
	}
	
	/**
	 * 
	 *
	 */
	public RsltTable( )
	{
		super();
	}

	public RsltTable( boolean p_IsOK )
	{
		super( p_IsOK );
	}
	
	/**
	 * 
	 * @param p_Cols
	 */
	public RsltTable( int p_Cols )
	{

		super( p_Cols ) ;
	}

	/**
	 * 
	 * @param p_Cols
	 * @param p_Rows
	 */
	public RsltTable( int p_Cols, int p_Rows )
	{

		super( p_Cols, p_Rows ) ;
		
		//init( p_Cols );
	}

	// ------------------------------------------
	/*
	public RsltTable( String[] p_ColNames ) 
	{

		super( p_ColNames.length );
		init( p_ColNames.length  );

		setColNames( p_ColNames );
	}
	*
	*
	**
	public RsltTable( int p_Cols ) 
	{

		super( p_Cols );
	}
	*
	***
	* Constructor with list of column names provided. 
	*
	public RsltTable( int p_Cols, String[] p_ColNames ) 
 	{

		super( p_Cols );
		
		init( p_Cols );

		setColNames( p_ColNames );
	}
	*
	
	**
	* Constructor with list of column names provided. 
	*
	public RsltTable( int p_Cols, int p_Rows, String[] p_ColNames ) 
	{

		super( p_Cols, p_Rows );
		
		init( p_Cols );

		setColNames( p_ColNames );
	}
	*/
}

